
require("sb_atlas")
math.randomseed(os.time())

local ATLAS_SPRITEBATCH           = nil 
local ATLAS_CACHE_MAPPING         = {}
local ATLAS_CACHE                 = {}

local OBJECTS = {}
local fps     = 0

function love.load()
  
  local ATLAS_W                   = 512 -- 1024, 2048, 4096, 8192, 16384
  local ATLAS_GF_PATH             = "gfx"
  local spritebatchMaxSprites     = 1000
  
  ATLAS_SPRITEBATCH    = newAtlas(ATLAS_W, ATLAS_GF_PATH, ATLAS_CACHE_MAPPING, ATLAS_CACHE, spritebatchMaxSprites)
  
  local screenW = love.graphics.getWidth()
  local screenH = love.graphics.getHeight()
  
  local edge  = 32
  local edge2 = edge * 2
  
  -- Add some objects directly from source path
  for i = 1, 100 do
    local x      = math.random(screenW + edge) - edge2
    local y      = math.random(screenH + edge) - edge2
    local source = "gfx/flora/leafy (" .. math.random(8) .. ").png"
    local quad   = imageCachedQuad(source)
    OBJECTS[i]   = {quad = quad, x = x, y = y}
  end
  
  -- more ...
  for i = 1, 10 do
    local x      = math.random(screenW + edge) - edge2
    local y      = math.random(screenH + edge) - edge2
    local source = "gfx/flora/nana.png"
    local quad  = imageCachedQuad(source)
    table.insert(OBJECTS, {quad = quad, x = x, y = y})
  end
  
  -- One last example
  local x      = math.random(screenW + edge) - edge2
  local y      = math.random(screenH + edge) - edge2
  local quad   = imageCachedQuad("gfx/fauna/monkey.png")
  table.insert(OBJECTS, {quad = quad, x = x, y = y})
  
  --
  love.graphics.setBackgroundColor(50, 40, 20)
  
end

function love.update(dt)    
  
  fps = love.timer.getFPS()
  
end

function love.draw()
  
  ATLAS_SPRITEBATCH:clear()
  
  for i = 1, #OBJECTS do
    local o = OBJECTS[i]
    ATLAS_SPRITEBATCH:add(o.quad, o.x, o.y)
  end
  
  love.graphics.draw(ATLAS_SPRITEBATCH)
  
  
  love.graphics.print(fps, 10, 10)
  
end

---
--
function imageCachedQuad(source)
  local mapping          = ATLAS_CACHE_MAPPING[source]
  return ATLAS_CACHE[mapping]
end